%define gimpplugin 0

Name:		xsane
Version:	0.999
Release:	%mkrel 19
Summary:	Frontend for the SANE scanner interface
Group:		Graphics/Scanning
License:	GPLv2+
URL:		http://www.xsane.org/
Source:		ftp://ftp.sane-project.org/pub/sane/xsane/%{name}-%version.tar.gz
Patch0:		xsane-0.995-xdg-open.patch
Patch1:		xsane-0.995-close-fds.patch
Patch2: 	xsane-0.996-no-eula.patch
Patch3:		xsane-0.997-off-root-build.patch
Patch4:		xsane-0.999-no-file-selected.patch
Patch5:		xsane-0.997-ipv6.patch
Patch6:		xsane-0.998-preview-selection.patch
Patch7:		xsane-0.998-libpng.patch
Patch8:		xsane-0.998-wmclass.patch
Patch9: 	xsane-desktop.patch
Patch10:	xsane-0.999-man-page.patch
Patch11:	xsane-0.999-pdf-no-high-bpp.patch
Patch12:	xsane-0.999-lcms2.patch
Patch13:	xsane-0.999-coverity.patch
Patch14:	xsane-0.999-snprintf-update.patch
Patch15:	xsane-0.999-signal-handling.patch
Patch16:	xsane-configure-implicit-function-declaration.patch
Patch17:    xsane-gamma-GCC15.patch
Patch18:    xsane-save-GCC15.patch

Requires:	libsane >= 1.0.4
# Contains "www-browser" script
Requires:	desktop-common-data
# This is for the drakxtools so that they can install a GUI for scanning
# but decide depending on the system environment which GUI actually to
# install
Provides:       scanner-gui
BuildRequires:	pkgconfig(sane-backends)
BuildRequires:	pkgconfig(libjpeg)
BuildRequires:	imagemagick
BuildRequires:  pkgconfig(lcms2)
BuildRequires:  pkgconfig(libtiff-4)
BuildRequires:  libgphoto-devel
BuildRequires:  libv4l-devel
BuildRequires:	gtk+2-devel
%if %{gimpplugin}
BuildRequires:	pkgconfig(gimp-2.0)
BuildRequires:	gtk+3.0-devel
%else
Obsoletes:	xsane-gimp < %{version}-%{release}
%endif
Recommends:	gocr

%description
XSane is an X based interface for the SANE (Scanner Access Now Easy)
library, which provides access to scanners, digital cameras, and other
capture devices.  XSane is written in GTK+ and provides control for
performing the scan and then manipulating the captured image.
%if %{gimpplugin}

You may install xsane-gimp if you want the GIMP plug-in.

%package gimp
Summary: 	GIMP plug-in which provides the SANE scanner interface
Group: 		Graphics/Scanning
Requires: 	sane >= 1.0, %{name} >= %{version}
 
%description gimp
This package provides the regular XSane frontend for the SANE scanner
interface, but it works as a GIMP 2.0 plug-in.  You must have GIMP 2.0 (or
newer) installed to use this package.
%endif

%prep
%setup -q
%patch -P0 -p1 -b .xdg-open
%patch -P1 -p1 -b .close-fds
#%%patch -P2 -p1 -b .no-eula
%patch -P3 -p1 -b .off-root-build
%patch -P4 -p1 -b .no-file-selected
%patch -P5 -p1 -b .ipv6
%patch -P6 -p1 -b .preview-selection.patch
%patch -P7 -p1 -b .libpng
%patch -P8 -p1 -b .wmclass
%patch -P9 -p1 -b .desktop-file
%patch -P10 -p1 -b .man-page
%patch -P11 -p1 -b .pdf-no-high-bpp
%patch -P12 -p1 -b .lcms2
%patch -P13 -p1 -b .coverity
%patch -P14 -p1 -b .snprintf-update
%patch -P15 -p1 -b .signal-handling
%patch -P16 -p1 -b .implicit-function-declaration
%patch -P17 -p1
%patch -P18 -p1

%build
%configure
%if %{gimpplugin}
%make_build
mv src/xsane src/xsane-gimp

make clean
%endif
%configure --disable-gimp
%make_build

%install
%make_install

%if %{gimpplugin}
install src/xsane-gimp %{buildroot}%{_bindir}
%endif

%find_lang %{name}

mkdir -p %{buildroot}%{_iconsdir}/hicolor/{48x48,32x32,16x16}/apps
mv src/xsane-48x48.png %{buildroot}%{_iconsdir}/hicolor/48x48/apps/%{name}.png
convert -scale 32 %{buildroot}/usr/share/pixmaps/xsane.xpm %{buildroot}%{_iconsdir}/hicolor/32x32/apps/%{name}.png
convert -scale 16 %{buildroot}/usr/share/pixmaps/xsane.xpm %{buildroot}%{_iconsdir}/hicolor/16x16/apps/%{name}.png

# dynamic desktop support
%define launchers /etc/dynamic/launchers/scanner
mkdir -p %{buildroot}%{launchers}
cat > %{buildroot}%{launchers}/%{name}.desktop << EOF
[Desktop Entry]
Name=XSane \$device
Comment=XSane
Exec=%{_bindir}/xsane
Terminal=false
Icon=%{name}
Type=Application
EOF

%files -f %{name}.lang
%doc xsane*
%config(noreplace) %{launchers}/%{name}.desktop
%{_bindir}/xsane
%dir %{_datadir}/sane
%{_datadir}/sane/*
%{_mandir}/man1/*
%{_datadir}/applications/%{name}.desktop
%{_datadir}/pixmaps/%{name}.xpm
%{_iconsdir}/hicolor/*/apps/*

%post
update-alternatives --install %{launchers}/kde.desktop scanner.kde.dynamic %{launchers}/%{name}.desktop 30
update-alternatives --install %{launchers}/gnome.desktop scanner.gnome.dynamic %{launchers}/%{name}.desktop 30

%postun
if [ $1 = 0 ]; then
  update-alternatives --remove scanner.kde.dynamic %{launchers}/%{name}.desktop
  update-alternatives --remove scanner.gnome.dynamic %{launchers}/%{name}.desktop
fi

%if %{gimpplugin}
%files gimp
%doc xsane*
%{_bindir}/xsane-gimp

%post gimp
if [ -d %{_libdir}/gimp ]; then
  GIMPDIR=`ls -d %{_libdir}/gimp/[012]*`
  [ -z "$GIMPDIR" ] && exit 0
  for i in $GIMPDIR;do
  [ -d $i/plug-ins ] || mkdir -p $i/plug-ins
  %__ln_s -f %{_bindir}/xsane-gimp $i/plug-ins/xsane
  done
fi

%postun gimp
if [ $1 = 0 ]; then
  if [ -d %{_libdir}/gimp ]; then
    GIMPDIR=`ls -d %{_libdir}/gimp/[012]*`
        [ -z "$GIMPDIR" ] && exit 0
        for i in $GIMPDIR;do
    [ -d $i/plug-ins ] || mkdir -p $i/plug-ins
    %{__rm} -f $i/plug-ins/xsane
        done
  fi
fi
%endif


%changelog
* Thu May 08 2025 philippedidier <philippedidier> 0.999-19.mga10
+ Revision: 2182046
- 2 patches to allow build with GCC15

* Fri Apr 18 2025 daviddavid <daviddavid> 0.999-18.mga10
+ Revision: 2176552
- disable gimp plugin not compatible with gimp3

* Sat Aug 10 2024 wally <wally> 0.999-17.mga10
+ Revision: 2085483
- fix build with gcc14

* Mon Dec 12 2022 ns80 <ns80> 0.999-16.mga9
+ Revision: 1921125
- rebuild for new libtiff

* Tue Apr 05 2022 umeabot <umeabot> 0.999-15.mga9
+ Revision: 1845043
- Mageia 9 Mass Rebuild

* Fri Jan 29 2021 daviddavid <daviddavid> 0.999-14.mga8
+ Revision: 1673896
- switch back to gimp 2.0

* Fri Jan 01 2021 luigiwalser <luigiwalser> 0.999-13.mga8
+ Revision: 1667505
- rebuild with gimp 3.0
- try rebuilding gimp plugin

* Fri Feb 14 2020 umeabot <umeabot> 0.999-12.mga8
+ Revision: 1518949
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Sun Sep 23 2018 umeabot <umeabot> 0.999-11.mga7
+ Revision: 1301973
- Mageia 7 Mass Rebuild

* Sun Aug 12 2018 wally <wally> 0.999-10.mga7
+ Revision: 1251184
- drop unused debug conditional from .spec
- clean unneeded parts and other .spec tidying

* Thu Aug 24 2017 ovitters <ovitters> 0.999-9.mga7
+ Revision: 1147141
+ rebuild (emptylog)

* Fri Mar 10 2017 akien <akien> 0.999-9.mga6
+ Revision: 1091643
- Rebuild for v4l-utils 1.12.3

* Wed Feb 17 2016 umeabot <umeabot> 0.999-8.mga6
+ Revision: 963652
- Mageia 6 Mass Rebuild

* Mon Sep 14 2015 zezinho <zezinho> 0.999-7.mga6
+ Revision: 879483
- recommends gocr #2896

* Mon Sep 14 2015 zezinho <zezinho> 0.999-6.mga6
+ Revision: 879245
- better icon

* Thu Jan 08 2015 alexl <alexl> 0.999-5.mga5
+ Revision: 809256
- added GenericName in desktop file

* Wed Nov 26 2014 alexl <alexl> 0.999-4.mga5
+ Revision: 799343
- add translations for desktop file from Mandriva and OpenSuse

* Wed Oct 15 2014 umeabot <umeabot> 0.999-3.mga5
+ Revision: 740787
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 0.999-2.mga5
+ Revision: 690767
- Mageia 5 Mass Rebuild

* Sat Aug 02 2014 spuhler <spuhler> 0.999-1.mga5
+ Revision: 659151
- changed BuildRequires:  lcms-devel to lcms2-devel
  * we want to obsolete lcms
- upgrade to vers. 0.999
- added patches from Fedora that have been accepted upstream
- removed unrecognized option --with-install-root=%%{buildroot}
- update from Fedora

* Sat Oct 19 2013 umeabot <umeabot> 0.998-5.mga4
+ Revision: 526231
- Mageia 4 Mass Rebuild

* Mon Jun 03 2013 fwang <fwang> 0.998-4.mga4
+ Revision: 436265
- rebuild for new libpng

* Mon Jan 14 2013 umeabot <umeabot> 0.998-3.mga3
+ Revision: 387380
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Oct 17 2012 fwang <fwang> 0.998-2.mga3
+ Revision: 307412
- update rpm group

* Sun Dec 25 2011 fwang <fwang> 0.998-2.mga2
+ Revision: 187456
- rebuild for new libtiff

* Fri Sep 16 2011 fwang <fwang> 0.998-1.mga2
+ Revision: 144208
- fix libpng 1.5
+ tv <tv>
- drop patch 2 (merged upstream)

* Thu Apr 14 2011 tv <tv> 0.998-1.mga1
+ Revision: 84892
- disable patch 2 (gcc-4.4)
- new release

* Thu Feb 10 2011 spuhler <spuhler> 0.997-3.mga1
+ Revision: 49630
- removed buildroot definition from .spec
  removed the if mdkversion lines
- imported package xsane

